module mds
#(	
	parameter DATA_WIDTH = 8
)
(
    input 				   			clk_i	,
    input 				   			reset_ni,
    input [DATA_WIDTH-1:0] 			box0_i	,
    input [DATA_WIDTH-1:0] 			box1_i	,
    input [DATA_WIDTH-1:0] 			box2_i	,
    input [DATA_WIDTH-1:0] 			box3_i	,
    output reg [(DATA_WIDTH*4)-1:0] mds_o
);
reg [DATA_WIDTH-1:0] mulBy5B_memory [0:(DATA_WIDTH*32)-1];
initial $readmemh("../../src/mul_by_5B.txt", mulBy5B_memory);

reg [DATA_WIDTH-1:0] mulByEF_memory [0:(DATA_WIDTH*32)-1];
initial $readmemh("../../src/mul_by_EF.txt", mulByEF_memory);

wire [DATA_WIDTH-1:0] z0;
wire [DATA_WIDTH-1:0] z1;
wire [DATA_WIDTH-1:0] z2;
wire [DATA_WIDTH-1:0] z3;

assign z0 = box0_i 				   ^ mulByEF_memory[box1_i] ^ mulBy5B_memory[box2_i] ^ mulBy5B_memory[box3_i];
assign z1 = mulBy5B_memory[box0_i] ^ mulByEF_memory[box1_i] ^ mulByEF_memory[box2_i] ^ box3_i				 ;
assign z2 = mulByEF_memory[box0_i] ^ mulBy5B_memory[box1_i] ^ box2_i				 ^ mulByEF_memory[box3_i];
assign z3 = mulByEF_memory[box0_i] ^ box1_i					^ mulByEF_memory[box2_i] ^ mulBy5B_memory[box3_i];


always @(posedge clk_i or negedge reset_ni) begin
    if(~reset_ni)
        mds_o <= 'b0;
    else
        mds_o <= {z3,z2,z1,z0};
end

endmodule