module reorder
#(parameter DATA_WIDTH = 128)
(
	input [DATA_WIDTH/4-1:0] p_i,
	output [DATA_WIDTH/4-1:0] arranged_o
);

assign arranged_o = plaintext_reorder(p_i);

function [(DATA_WIDTH/4)-1:0] plaintext_reorder;
	input [(DATA_WIDTH/4)-1:0] plaintext;
	reg [(DATA_WIDTH/32)-1:0] plaintext_split [7:0];
	begin
		{plaintext_split[7],plaintext_split[6],plaintext_split[5],plaintext_split[4],plaintext_split[3],plaintext_split[2],plaintext_split[1],plaintext_split[0]} = plaintext [(DATA_WIDTH/4)-1:0];
		plaintext_reorder = {plaintext_split[1],plaintext_split[0],plaintext_split[3],plaintext_split[2],plaintext_split[5],plaintext_split[4],plaintext_split[7],plaintext_split[6]};
	end
endfunction

endmodule